'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _url = require('url');

var _url2 = _interopRequireDefault(_url);

var _requestPromiseNative = require('request-promise-native');

var _requestPromiseNative2 = _interopRequireDefault(_requestPromiseNative);

var _htmlparser = require('htmlparser2');

var _htmlparser2 = _interopRequireDefault(_htmlparser);

var _lodash = require('lodash');

var _lodash2 = _interopRequireDefault(_lodash);

var _ent = require('ent');

var _ent2 = _interopRequireDefault(_ent);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var ProxyResource = function () {
  function ProxyResource(req, options) {
    _classCallCheck(this, ProxyResource);

    this.req = req;
    this.proxyURL = options.proxyUrl;

    this.url = req.url;
    this.parsedUrl = _url2.default.parse(this.url);
    this.host = this.parsedUrl.protocol + '//' + this.parsedUrl.host;
  }

  _createClass(ProxyResource, [{
    key: 'load',
    value: function load() {
      var headers;
      return regeneratorRuntime.async(function load$(_context) {
        while (1) {
          switch (_context.prev = _context.next) {
            case 0:
              headers = this.req.headers;

              headers.host = this.parsedUrl.host;
              headers.referer = this.host + '/';
              delete headers['accept-encoding'];
              return _context.abrupt('return', (0, _requestPromiseNative2.default)({
                method: this.req.method,
                uri: this.url,
                resolveWithFullResponse: true,
                encoding: null,
                headers: headers
              }));

            case 5:
            case 'end':
              return _context.stop();
          }
        }
      }, null, this);
    }
  }, {
    key: 'proxy',
    value: function proxy() {
      var _this = this;

      return regeneratorRuntime.async(function proxy$(_context3) {
        while (1) {
          switch (_context3.prev = _context3.next) {
            case 0:
              return _context3.abrupt('return', new Promise(function _callee(resolve, reject) {
                var response;
                return regeneratorRuntime.async(function _callee$(_context2) {
                  while (1) {
                    switch (_context2.prev = _context2.next) {
                      case 0:
                        response = void 0;
                        _context2.prev = 1;
                        _context2.next = 4;
                        return regeneratorRuntime.awrap(_this.load());

                      case 4:
                        response = _context2.sent;
                        _context2.next = 11;
                        break;

                      case 7:
                        _context2.prev = 7;
                        _context2.t0 = _context2['catch'](1);

                        resolve({
                          statusCode: _context2.t0.statusCode,
                          headers: _this.filterResponseHeaders(_context2.t0.response.headers),
                          body: _this.parse(_context2.t0.response)
                        });
                        return _context2.abrupt('return');

                      case 11:

                        resolve({
                          statusCode: response.statusCode,
                          headers: _this.filterResponseHeaders(response.headers),
                          body: _this.parse(response)
                        });

                      case 12:
                      case 'end':
                        return _context2.stop();
                    }
                  }
                }, null, _this, [[1, 7]]);
              }));

            case 1:
            case 'end':
              return _context3.stop();
          }
        }
      }, null, this);
    }
  }, {
    key: 'filterResponseHeaders',
    value: function filterResponseHeaders(headers) {
      return _lodash2.default.omit(headers, 'x-frame-options');
    }
  }, {
    key: 'parse',
    value: function parse(response) {
      var contentType = response.headers['content-type'];
      if (contentType.includes('text/html')) {
        return this.parseHTML(response.body.toString());
      } else if (contentType.includes('text/css')) {
        return this.parseCSS(response.body.toString());
      }
      return response.body;
    }
  }, {
    key: 'parseHTML',
    value: function parseHTML(body) {
      var output = '' + body;
      var urls = [];
      var urlAttrs = ['href', 'src'];

      var parser = new _htmlparser2.default.Parser({
        onopentag: function onopentag(name, attrs) {
          for (var i = 0; i < urlAttrs.length; i++) {
            var attr = urlAttrs[i];
            if (attrs[attr]) {
              urls.push(attrs[attr]);
            }
          }
        }
      }, { decodeEntities: false });
      parser.write(body);
      parser.end();

      var matches = [];
      for (var i = 0; i < urlAttrs.length; i++) {
        var attr = urlAttrs[i];
        matches.push(attr + '="$0"');
        matches.push(attr + '=\'$0\'');
        matches.push(attr + '=$0');
      }

      for (var i = 0; i < urls.length; i++) {
        var url = urls[i];
        if (url.indexOf('#') === 0) {
          continue;
        }

        var newUrl = this.resolveURL(_ent2.default.decode(url));

        for (var j = 0; j < matches.length; j++) {
          var match = matches[j];
          output = output.replace(match.replace('$0', url), match.replace('$0', newUrl));
        }
      }

      return output;
    }
  }, {
    key: 'parseCSS',
    value: function parseCSS(body) {
      var _this2 = this;

      var output = '' + body;
      output = output.replace(/url\((.*?)\)/ig, function (match, $0) {
        if ($0.indexOf('data:') === 0) {
          return 'url(' + $0 + ')';
        }

        var url = $0.replace(/^"|'/, '');
        url = url.replace(/"|'$/, '');
        return 'url(' + _this2.resolveURL(url) + ')';
      });
      return output;
    }
  }, {
    key: 'resolveURL',
    value: function resolveURL(url) {
      var resolved = void 0;
      if (url.indexOf('//') === 0) {
        resolved = '' + this.parsedUrl.protocol + url;
      } else {
        resolved = _url2.default.resolve(this.url, url);
      }
      return '' + this.proxyURL + encodeURIComponent(resolved);
    }
  }]);

  return ProxyResource;
}();

exports.default = ProxyResource;